//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

//
// WARNING: Generated file, do not edit by hand!
//

/** \file inst/bne.hh
    \brief Declare the interface of Bne */
#ifndef INST_BNE_HH
# define INST_BNE_HH

# include "inst/register.hh"
# include "inst/exp.hh"
# include "inst/inst.hh"

namespace inst
{

  /// Declare Bne.
  /** Branch to label if src1 does not equal src2.  */
  class Bne:
    public Inst
  {
    /** \name Ctor & dtor.
        \{ */
  public:
    /// Construct a(n) Bne node.
    Bne(const Register &src1, const Register &src2, const CountedExp &label);
    /// Destroy a(n) Bne node.
    virtual ~Bne();
    /** \} */

    /** \name Accessors.
        \{ */
  public:
    /// Return src1
    const Register &		get_src1() const ;
    /// Return src1
    Register &		get_src1() ;
    /// Return src2
    const Register &		get_src2() const ;
    /// Return src2
    Register &		get_src2() ;
    /// Return label
    const Exp &		get_label() const ;
    /// Return label
    Exp &		get_label() ;
    /** \} */

    /** \name Visitors entry point.
        \{ */
  public:
    /// Accept a const visitor \a v.
    virtual void accept(ConstVisitor& v) const;
    /// Accept a non-const visitor \a v.
    virtual void accept(Visitor& v);
    /** \} */

  public:
    /// Print this
    virtual void	write(std::ostream &ostr) const;

  protected:
    Register	src1_;
    Register	src2_;
    CountedExp	label_;
  };

} // namespace inst

# include "inst/bne.hxx"

#endif // !INST_BNE_HH
