//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef INST_EXP_HH
# define INST_EXP_HH

# include <ostream>

# include "misc/lockable.hh"
# include "misc/counted_ptr.hh"

# include "inst/fwd.hh"

namespace inst
{

  class Exp:
    public misc::lockable
  {
  protected:
    Exp();
  public:
    virtual ~Exp();

  public:
    virtual void write(std::ostream &ostr) const;

    virtual void accept(ConstExpVisitor &v) const = 0;
    virtual void accept(ExpVisitor &v) = 0;

  public:
    void set_immediate(int i);
    int get_immediate() const;

    operator int () const;

  protected:
    int immediate_;
  };

  //
  std::ostream &
  operator<<(std::ostream &ostr, const Exp &e);

  //
  typedef misc::counted_ptr<Exp> CountedExp;

} // namespace inst

# include "inst/exp.hxx"

#endif // !INST_EXP_HH
