//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef INST_INST_HH
# define INST_INST_HH

# include <ostream>

# include "inst/visitor.hh"

namespace inst
{

  class Inst
  {
  public:
    enum format_type
      {
	i_type = 0,
	r_type = 1,
	j_type = 2
      };

  public:
    Inst(format_type format);
    virtual ~Inst();

  public:
    virtual void accept(ConstVisitor &v) const = 0;
    virtual void accept(Visitor &v) = 0;

  public:
    virtual void write(std::ostream&) const = 0;

  public:
    format_type	get_format() const;

  private:
    const format_type format_;
  };

  std::ostream &
  operator<<(std::ostream &ostr, const Inst &i);

} // namespace inst

# include "inst/inst.hxx"

#endif // !INST_INST_HH
