//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef INST_INT_EXP_HH
# define INST_INT_EXP_HH

# include "inst/exp.hh"

namespace inst
{

  class IntExp:
    public Exp
  {
  public:
    IntExp(int integer);
    virtual ~IntExp();

  public:
    virtual void accept(ConstExpVisitor &v) const;
    virtual void accept(ExpVisitor &v);
  };

} // namespace inst

# include "inst/int_exp.hxx"

#endif // !INST_INT_EXP_HH
