#!/usr/bin/env python
##
## This file is part of Nolimips, a MIPS simulator with unlimited registers
## Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
##
## Nolimips is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## Nolimips is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import sys, os
import string, re

import nolimips
from nolimips import depth

#### Nolimips' inst/Makefile.am generator ------------------

parser = nolimips.InstructionSetParser()
instructions = parser.parse(sys.stdin)

print "FROM_NODES_GEN_PY =			\\"
for i in range(0, len(instructions)):
  if instructions[i].level == "native":
    line = "\t"
    for ext in ["hh", "hxx", "cc"]:
      line = line + instructions[i].opcode + "." + ext + " "
    print line + "\t\t\\"
print """	fwd.hh					\\
	all.hh					\\
	visitor.hh"""
